#include "X3D_BBoxUpdaterShapeVisitor.h"
#include "X3D_X3DShapeNode.h"
#include "X3D_Shape.h"
#include "BBox.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

BBoxUpdaterShapeVisitor::BBoxUpdaterShapeVisitor()
: ShapeVisitor()
{
  // WalkOn functions.
  define(Recorder<X3DShapeNode>::getWalkOnFunction(&BBoxUpdaterShapeVisitor::walkOnX3DShapeNode));

  // Leave functions.
  define(Recorder<Shape>::getLeaveFunction(&BBoxUpdaterShapeVisitor::leaveShape));
}

bool BBoxUpdaterShapeVisitor::walkOnX3DShapeNode(X3DShapeNode *, SFAbstractNode) 
{
  return true;
}

void BBoxUpdaterShapeVisitor::leaveShape(Shape *S) 
{
  BBoxUpdaterStateVariables *stateVariables = Singleton<BBoxUpdaterStateVariables>::getInstance();
  BBox *BB = stateVariables->getBBox(S);
  if (BB == 0)
  {
    BB = new BBox(stateVariables->getShapeBBox());
    S->setBBoxCenter(BB->getCenter());
    S->setBBoxSize(BB->getSize());
    stateVariables->addBBox(S, BB); 
  }
}

}
}
