#include "X3D_WorldCoordTranslatorMulGroupingVisitor.h"
#include "X3D_Group.h"
#include "X3D_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

WorldCoordTranslatorMulGroupingVisitor::WorldCoordTranslatorMulGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  define(Recorder<Transform>::getEnterFunction(&WorldCoordTranslatorMulGroupingVisitor::enterTransform));
  
  // Leave functions.
  define(Recorder<Transform>::getLeaveFunction(&WorldCoordTranslatorMulGroupingVisitor::leaveTransform));
}

void WorldCoordTranslatorMulGroupingVisitor::enterTransform(Transform *T) 
{
  WorldCoordTranslatorStateVariables *stateVariables = Singleton<WorldCoordTranslatorStateVariables>::getInstance();
  
  SFMatrix34f transform(T->getTranslation(), T->getCenter(), T->getRotation(), T->getScaleOrientation(), T->getScale());
  
  T->setCenter(SFVec3f(0.0f, 0.0f, 0.0f));
  T->setRotation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f));
  T->setScale(SFVec3f(1.0f, 1.0f, 1.0f));
  T->setScaleOrientation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f));
  T->setTranslation(SFVec3f(0.0f, 0.0f, 0.0f));
  
  stateVariables->pushMatrix(transform);
}

void WorldCoordTranslatorMulGroupingVisitor::leaveTransform(Transform *) 
{
  WorldCoordTranslatorStateVariables *stateVariables = Singleton<WorldCoordTranslatorStateVariables>::getInstance();
  
  stateVariables->popMatrix();
}

}
}
