#include "Cloner.h"
#include "X3DAbstractNode.h"
#include "DFSGraphTraversal.h"
#include "ClonerAbstractVisitor.h"

namespace X3DTK {

Cloner::Cloner()
{
  stateVariables = Singleton<ClonerStateVariables>::getInstance();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new ClonerAbstractVisitor());
}

Cloner::~Cloner()
{
  Singleton<ClonerStateVariables>::removeInstance();
  
  delete graphTraversal;
}
  
SFAbstractNode Cloner::clone(SFAbstractNode N, bool reset) const
{
  stateVariables->initRoot();
  if (reset)
    stateVariables->init();
    
  graphTraversal->traverse(N);

  if (reset)  
    stateVariables->finish();
  
  return stateVariables->getRoot();
}

void Cloner::init()
{
  stateVariables->init();
}

void Cloner::finish()
{
  stateVariables->finish();
}
  
}
